/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Jianfeng Gao ( jianfeng dot gao at kit dot edu )
 * @date       2022
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once
#include <Eigen/Geometry>


namespace armarx::control::common
{

class MultivariateNormal
{
public:
    MultivariateNormal(const Eigen::VectorXf& mu, const Eigen::MatrixXf& cov);
    MultivariateNormal(const Eigen::VectorXf& mu, float std);
    ~MultivariateNormal();
    float pdf(const Eigen::VectorXf& x) const;
    Eigen::VectorXf pdf_gradient(const Eigen::VectorXf& x) const;
    Eigen::VectorXf sample(unsigned int nr_iterations = 20) const;
    Eigen::VectorXf mean;
    Eigen::MatrixXf covariance;
};

Eigen::VectorXf pdf_gradient(const Eigen::VectorXf& mean, float std, const Eigen::VectorXf &x);
}
