#pragma once

#include <string>

#include <RobotAPI/interface/units/HandUnitInterface.h>
#include <RobotAPI/interface/units/KinematicUnitInterface.h>

#include <armarx/control/skills/skills/aron/ShapeHandParams.aron.generated.h>

namespace armarx::control::skills
{
    struct KinematicUnitRemote
    {
        ::armarx::KinematicUnitInterfacePrx kinematicUnit;
    };

    struct HandUnitRemote
    {
        ::armarx::HandUnitInterfacePrx& leftHandUnit;
        ::armarx::HandUnitInterfacePrx& rightHandUnit;

        ::armarx::HandUnitInterfacePrx&
        getHandUnit(const skills::Hand hand)
        {
            if (hand == skills::Hand::Left)
            {
                return leftHandUnit;
            }
            else // hand == Hand::Right
            {
                return rightHandUnit;
            }
        }
    };

} // namespace armarx::control::skills
